function[pd,td,pa,ta, c_rec,c_exp,e_rec,e_exp]=diss_cycle2(x,P,T,first)
x=log(x);
t=length(x);

if first==0
%Introduce the first and last phases!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
if P(1) < T(1) && P(1)~= 1% Peaks are first 
    T=[1;T]; 
elseif P(1) > T(1) && T(1)~= 1 % % Troughs are First 
    P=[1;P];
end
 
if P(end) < T(end) && T(end)~= t % The last is trough
    P=[P;t]; 
elseif P(end) > T(end) && P(end) ~= t % % The last is peak
    T=[T;t];
end
end

%DURATIONS
%Calculate Peak To Trough Durations 
if P(1,1) < T(1,1) % Peaks are first 
r=min([length(P);length(T)]);

 pd=T(1:r,1)-P(1:r,1);
else                     % Troughs are First 
 r=min([length(P);length(T)-1]);
 pd=T(2:r+1,1)-P(1:r,1);
end
pd_mean=mean(pd); %#ok<NASGU> %duration of recesions

%Calculate Trough to Peak Durations 
if T(1,1)< P(1,1) %Troughs are first 
 r=min([length(T);length(P)]);
 td=P(1:r,1)-T(1:r,1);
else                     %Troughs are First 
 r=min([length(T);length(P)-1]);
 td=P(2:r+1,1)-T(1:r,1);
end
 td_mean=mean(td); %#ok<NASGU> %duration of expansions

%AMPLITUDE
xp=NaN(1,length(P));
for i=1:length(P)
    xp(i)=x(P(i));
end
xt=NaN(1,length(T));
for i=1:length(T)
    xt(i)=x(T(i));
end
xp=xp';
xt=xt';
%Calculate Peak To Trough amplitude 
if P(1,1) < T(1,1) % Peaks are first 
 r=min([length(P);length(T)]);
 pa=xt(1:r,1)-xp(1:r,1);
else                     % Troughs are First 
 r=min([length(P);length(T)-1]);
 pa=xt(2:r+1,1)-xp(1:r,1);
end
pa_mean=mean(pa)*100; %#ok<NASGU> %amplitude of recesions

%Calculate Trough to Peak Durations 
if T(1,1)< P(1,1) %Troughs are first 
 r=min([length(T);length(P)]);
 ta=xp(1:r,1)-xt(1:r,1);
else                     %Troughs are First 
 r=min([length(T);length(P)-1]);
 ta=xp(2:r+1,1)-xt(1:r,1);
end
 ta_mean=mean(ta)*100; %#ok<NASGU> %amplitude of expansions

%CUMULATION_tri
c_rec_tri=pd.*pa/2; %#ok<NASGU> %triangular cumulation recession
c_exp_tri=td.*ta/2; %triangular cumulation expansion


%EXCESS
%for recessions
R=[];
i=1;
while(i<=length(P))
    j=1;
    while(j<=length(T))
        if T(j)>P(i)
            R(i,1)=P(i);  %#ok<AGROW>
            R(i,2)=T(j); %#ok<AGROW>
            break
        end
        j=j+1;
    end
    i=i+1;
end

if isempty(R)==0
    I_rec=NaN(1,size(R,1));
    c_rec_true=NaN(1,size(R,1));
    c_rec_tri=NaN(1,size(R,1));
    e_rec=NaN(1,size(R,1));
    
for i=1:size(R,1)
    num_R_points=R(i,2)-R(i,1)+1;
    R_points=1:1:num_R_points;
    fR_points=x(R(i,1):R(i,2));
    fR_points=fR_points-min(fR_points);
    I_rec(i)=integral(R_points,fR_points);
    c_rec_true(i)=I_rec(i);
    c_rec_tri(i);
    e_rec(i)=((c_rec_true(i)-abs(c_rec_tri(i))));
    %Excess>0 concave recession, excess<0 convex recession
    %the interpretacion is the opposite to expansions, see bellow
    %be careful, we make area_tri-area_tru but the integral is 
    %caltulate according to axes position, so the peak is on the "y" axe and
    %the thought on the "x" axe 
end
c_rec=-I_rec';
c_rec_mean=mean(c_rec)*100; %#ok<NASGU>
e_rec=e_rec';
e_rec2=e_rec./pd; %#ok<NASGU>
e_rec_mean=mean(e_rec)*100; %#ok<NASGU>
else
    c_rec=NaN;
    c_rec_mean=NaN; %#ok<NASGU>
    e_rec=NaN;
    e_rec2=NaN; %#ok<NASGU>
    e_rec_mean=NaN; %#ok<NASGU>
end

%for expansions
E=[];
i=1;
while(i<=length(T))
    j=1;
    while(j<=length(P))
        if P(j)>T(i)
            E(i,1)=T(i);  %#ok<AGROW>
            E(i,2)=P(j); %#ok<AGROW>
            break
        end
        j=j+1;
    end
    i=i+1;
end

if isempty(E)==0
    I_exp=NaN(1,size(E,1));
    c_exp_true=NaN(1,size(E,1));
    e_exp=NaN(1,size(E,1));
    
for i=1:size(E,1)
    num_E_points=E(i,2)-E(i,1)+1;
    E_points=1:1:num_E_points;
    fE_points=x(E(i,1):E(i,2));
    fE_points=fE_points-min(fE_points);
    I_exp(i)=integral(E_points,fE_points);
    c_exp_true(i)=I_exp(i);
    e_exp(i)=((abs(c_exp_true(i))-c_exp_tri(i))); 
    %Excess>0 concave expansion, 
    %We consider that the origin of axes is the through
    %So, any linear combination of two points of the curve is below the
    %curve and the second derivative is negative
    %actual paths start the phase of the cycle with steep changes (third pahse) and end the phase smoothly.
    %Typical behaviour before the GM

    %excess<0 convexe expansion
    %Any linear combination of two points of the curve is up the
    %curve and the second derivative is negative
    %actual paths exhibit gradual changes in the slope at the beginning of the phase, 
    %but they become abrupt as the end of the phase comes. 
    %Typical behaviour after the GM
end


c_exp=I_exp';
c_exp_mean=mean(I_exp)*100; %#ok<NASGU>
e_exp=e_exp';
e_exp2=e_exp./td; %#ok<NASGU>
e_exp_mean=mean(e_exp)*100; %#ok<NASGU>

else
    c_exp=NaN;
    c_exp_mean=NaN; %#ok<NASGU>
    e_exp=NaN;
    e_exp2=NaN; %#ok<NASGU>
    e_exp_mean=NaN; %#ok<NASGU>
end




function [I]=integral(x,fx)
n=length(x);
int=zeros(n-1,1);
for i=1:n-1
    int(i)=((x(i+1)-x(i))/2)*(fx(i)+fx(i+1));
end
I=sum(int);
